#ifndef CALLBACKS
#define CALLBACKS
#include <gtk/gtk.h>
#define GTK
#ifndef SIRIL
#include "siril.h"
#endif
#include <ctype.h>

#define CONVPAGE 0
#define SELPAGE 1
#define SEQPAGE 2
#define MESPAGE 3

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
on_minscale_changed      (GtkAdjustment *adj,
                                        gpointer         user_data);

gboolean
on_maxscale_changed      (GtkAdjustment *adj,
                                        gpointer         user_data);

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_open_ok_button1_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_open_cancel_button1_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_exit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

gboolean
on_command_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_command_key_release_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_command_key_release_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_command_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_command_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_command_changed_event               (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
redrawrvb(int x, int y);

void set_ranges(void);
gboolean redraw(int vport, int remap);

void remap(int vport);
void remaprvb(void);
#endif /* CALLBACKS */

void
on_drawingarea1_drag_begin             (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_command_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

void
on_registration1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_reg_cancel_button_released          (GtkButton       *button,
                                        gpointer         user_data);

void
on_reg_ok_button_released              (GtkButton       *button,
                                        gpointer         user_data);

void
on_stack1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stack_ok_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_stack_cancel_button_released        (GtkButton       *button,
                                        gpointer         user_data);

void
on_stack_useshiftfile_button_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_stack_ok_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_median_stack1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_auto_level_button1_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_medstack_ok_btton_released          (GtkButton       *button,
                                        gpointer         user_data);

void
on_medstack_cancel_button_released     (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_scalemax_drag_motion                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_scalemin_drag_motion                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_max_entry_changed                   (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_min_entry_changed                   (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_index_length_spinbutton_changed     (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_fixed_length_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

gboolean
on_main_window_key_press_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_button1_released                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_sequence_processing1_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_usedarkbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_useoffsetbutton_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_useflatbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_excludebutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_imagenumberspin_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
on_imagenumberspin_key_release_event   (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_seqexcludeall_button_released       (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqselectall_button_released        (GtkButton       *button,
                                        gpointer         user_data);

void
on_writeschedule_button_released       (GtkButton       *button,
                                        gpointer         user_data);

void
on_prepro_button_released              (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqregister_button_released         (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqstack_button_released            (GtkButton       *button,
                                        gpointer         user_data);


void
on_showexcluded_button_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convert_button_released             (GtkButton       *button,
                                        gpointer         user_data);

void
on_medianstack_button_released         (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqmedianstack_button_released      (GtkButton       *button,
                                        gpointer         user_data);

void
on_selseqname_entry_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_darkname_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_offsetname_entry_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_flatname_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_preproseqname_entry_changed         (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_selseqprefix_entry_changed          (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_selprefix_entry_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_cwd_btton_released                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button2_released                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button2_released             (GtkButton       *button,
                                        gpointer         user_data);

void
on_darkfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqproc_entry_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cwd_btton_released                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_offsetfile_button_released          (GtkButton       *button,
                                        gpointer         user_data);

void
on_flatfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_darkfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_flatfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_darkfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

void
on_hide_seqproc_button_released        (GtkButton       *button,
                                        gpointer         user_data);

void
on_hide_fileconv_button_released       (GtkButton       *button,
                                        gpointer         user_data);

void
on_convfromroot_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_convsourcesuffix_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_convall_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convindex_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convfromentry_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_convtoentry_changed                 (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_convusfbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convspinbutton_changed              (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_convbmp_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convpng_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convjpg_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_convtoroot_changed                  (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_conv3planefit_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_conv3_1plane_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_conv1_1plane_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_fileconv_button_released            (GtkButton       *button,
                                        gpointer         user_data);

void
on_seqproc_button_released             (GtkButton       *button,
                                        gpointer         user_data);

void
on_exit_button_released                (GtkButton       *button,
                                        gpointer         user_data);


void
on_darkname_entry_changed              (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_darkfile_button_released            (GtkButton       *button,
                                        gpointer         user_data);
void rgbprocess(gboolean value);

void
on_rgb_button_released                 (GtkButton       *button,
                                        gpointer         user_data);


void
on_filecombo_entry_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_filecombo_entry_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

gboolean
on_mainseqname_entry_changed           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_mainseqname_entry_changed           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_notebook2_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data);

void
on_checkseqbutton_released             (GtkButton       *button,
                                        gpointer         user_data);

void
on_confirmok_released                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_confirmcancel_released              (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_drawingarea_key_press_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);

void
on_convavi_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
