#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/time.h>
#include <dirent.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "siril.h"
#define MAXWORD 16
#define MAXCHAR 128

char sourceroot[256];
char destroot[256];
char sourcesuf[256]="bmp";
char destsuf[256]="fit";
char sourcefilename[256];
char destfilename[256];
char *name;
int from;
int to, fixed;
int type;
unsigned short convstatus=CONV1X3|CONVBMP|CONVALL;
static char pnmpath[255]={"/usr/bin"};
static char pnmcom[3][255]={"pngtopnm","jpegtopnm","bmptopnm"};
unsigned char *bmp;
fits r,g,b,rgb;
char word[MAXWORD][MAXCHAR];
char combuffer[512];
	

void
on_convfromroot_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	name=gtk_entry_get_text(GTK_ENTRY(editable));
	strncpy(sourceroot,name,MAXGENLENGTH);
}


void
on_convsourcesuffix_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
	name=gtk_entry_get_text(GTK_ENTRY(editable));
	strncpy(sourcesuf,name,MAXGENLENGTH);
}


void
on_convall_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus|=CONVALL;
	gtk_widget_set_sensitive (lookup_widget(main_window,"conv_from_entry"), FALSE);
	gtk_widget_set_sensitive (lookup_widget(main_window,"entry5"), FALSE);
}


void
on_convindex_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus&=~CONVALL;
	gtk_widget_set_sensitive (lookup_widget(main_window,"conv_from_entry"), TRUE);
	gtk_widget_set_sensitive (lookup_widget(main_window,"entry5"), TRUE);
}


void
on_convfromentry_changed               (GtkEditable     *editable,
                                        gpointer         user_data)
{
	name=gtk_entry_get_text(GTK_ENTRY(editable));
	from=atoi(name);
}


void
on_convtoentry_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
	name=gtk_entry_get_text(GTK_ENTRY(editable));
	to=atoi(name);
}


void
on_convusfbutton_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if((gtk_toggle_button_get_active (togglebutton)==FALSE)){
		convstatus &= ~CONVUFL;
		}
	else{
		convstatus |= CONVUFL;
		}		

}


void
on_convspinbutton_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
	fixed=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(editable));
}


void
on_convbmp_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONVBMP;
	convstatus &= ~(CONVJPG|CONVPNG|CONVAVI);
	type=TYPEBMP;
}


void
on_convpng_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONVPNG;
	convstatus &= ~(CONVJPG|CONVBMP|CONVAVI);
	type=TYPEPNG;
}

void
on_convavi_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONVAVI;
	convstatus &= ~(CONVJPG|CONVBMP|CONVPNG);
	type=TYPEAVI;
}


void
on_convjpg_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONVJPG;
	convstatus &= ~(CONVBMP|CONVPNG|CONVAVI);
	type=TYPEJPG;
}


void
on_convtoroot_changed                  (GtkEditable     *editable,
                                        gpointer         user_data)
{
	name=gtk_entry_get_text(GTK_ENTRY(editable));
	strncpy(destroot,name,MAXGENLENGTH);
	fprintf(stderr,"destroot %s\n", destroot);
}


void
on_conv3planefit_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONV1X3;
	convstatus &= ~(CONV3X1|CONV1X1);
}


void
on_conv3_1plane_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONV3X1;
	convstatus &= ~(CONV1X1|CONV1X3);
}


void
on_conv1_1plane_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	convstatus |= CONV1X1;
	convstatus &= ~(CONV3X1|CONV1X3);
}

char *buildfname(char *dest, char *name, char *suf, int index){
	char format[256];

	isempty(name);
// do we need a fixed length index ?
	if (convstatus & CONVUFL){
		sprintf(format,"%%s%%d.%%s");
		}
	else {
		sprintf(format,"%%s%%.%dd.%%s", fixed);
		}
	snprintf(dest, 255, format, name, index, suf);
	return dest;
	}


void
on_convert_button_released (GtkButton *button, gpointer user_data)
{
	int i;

	DIR *dir;
	struct dirent *file;
	char *ext, *ext2, *zeropointe;
	int length_sourceroot=strlen(sourceroot);
	
	isempty(sourceroot);	
	isempty(destroot);	

	if (convstatus & CONVAVI){
		if(! (convstatus & CONV1X1)){
			fprintf(stderr,"/usr/bin/mplayer -fps 500 -vo pnm %s.%s ", sourceroot,sourcesuf);
			snprintf(combuffer,511,"/usr/bin/mplayer -fps 500 -vo pnm %s.%s ", sourceroot,sourcesuf);
			sprintf(sourcesuf,"pnm");
			}
		else{
			fprintf(stderr,"/usr/bin/mplayer -fps 500 -vo pnm:pgm %s.%s", sourceroot,sourcesuf);
			snprintf(combuffer,511,"/usr/bin/mplayer -fps 500 -vo pnm:pgm %s.%s", sourceroot,sourcesuf);
			sprintf(sourcesuf,"pgm");
			}
		if (system(combuffer))
			fprintf(stderr, "command %s failed\n", combuffer);
		sourceroot[0]=0;
		convstatus|=(CONVPNM|CONVALL);
		}

	if (convstatus & CONVALL){
			if((dir=opendir(com.wd))==NULL){
				fprintf(stderr,"%s\n",com.wd);
				return ;
				}
			i=0;
			while ((file=readdir(dir))!=NULL){
				if (	((! sourceroot[0]) || 
						strstr(file->d_name, sourceroot)==file->d_name) && 
						strstr(file->d_name, sourcesuf)){
						
					if(convstatus&CONVAVI){
						zeropointe=(char *)(file->d_name);
						while (*zeropointe++=='0');
						strncpy(sourcefilename,file->d_name,255);
						snprintf(destfilename,255, "%s%s",destroot,--zeropointe);
						}
					else{
						length_sourceroot=strlen(sourceroot);
						strncpy(sourcefilename,file->d_name,255);
						strncpy(destfilename,file->d_name,255);
						snprintf(destfilename,255, "%s%s",destroot,file->d_name+length_sourceroot);
						}	
					ext2=destfilename;
					while ((ext=strstr(ext2,sourcesuf))){
						ext2=ext+1;
						}

					strcpy(--ext2,destsuf);
					tofits(sourcefilename, destfilename);
					snprintf(com.status,255,"Converting %s", sourcefilename);
					progress(0);
					}
				}
		}
	else {
		for (i=from; i<=to;++i){
	fprintf(stderr,"conv destroot %s\n", destroot);
			buildfname(sourcefilename,sourceroot,sourcesuf,i);
			buildfname(destfilename,destroot,destsuf,i);

			tofits(sourcefilename, destfilename);
			snprintf(com.status,255,"Converting %s", sourcefilename);
			progress(0);
			}
		}
	}

/*
 *	Convertit 1 bmp24 rvb dans 1 fits 24 ou 48 bits  NAXIX=3 et NAXIS3=3
 *	(la mmoire est ralloue de celle de fitr,v,b si possible)
 */
 int bmp24tofits(unsigned char *rvb, int rx, int ry, fits *fitr){
	int i, j, nbdata;
	short *rdata, *gdata, *bdata;
	unsigned char *brdata,*bgdata,*bbdata;

	fprintf(stderr,"bmp24tofits: %d x %d \n",rx,ry);
	nbdata=rx*ry;
	if(fitr->bitpix==SIZESHORT){
		fprintf(stderr,"bmp24tofits: SHORT \n");
		if((fitr->data=realloc(fitr->data,rx* ry*3*sizeof(WORD)))==NULL){
			fprintf(stderr,"readfits: error alloc fit1\n");
			return(1);
			}

		rdata=fitr->pdata[0]=fitr->data;
		gdata=fitr->pdata[1]=fitr->data+nbdata;
		bdata=fitr->pdata[2]=fitr->data+2*nbdata;
		for (i=0; i<rx; ++i){
			for (j=0; j<ry; ++j){
				*bdata++=*rvb++;
				*gdata++=*rvb++;
				*rdata++=*rvb++;
				}	
			}
		}
	
	if(fitr->bitpix==SIZEBYTE){
		fprintf(stderr,"bmp24tofits: BYTE \n");
		if((fitr->cdata=realloc(fitr->cdata,rx* ry*3*sizeof(unsigned char)))==NULL){
			fprintf(stderr,"readfits: error alloc fit1\n");
			return(1);
			}

		brdata=fitr->cdata;
		bgdata=fitr->cdata+nbdata;
		bbdata=fitr->cdata+2*nbdata;
		for (i=0; i<rx; ++i){
			for (j=0; j<ry; ++j){
				*bbdata++=*rvb++;
				*bgdata++=*rvb++;
				*brdata++=*rvb++;
				}	
			}
		}
	
	fitr->rx=rx;
	fitr->ry=ry;
	fitr->naxes[0]=rx;
	fitr->naxes[1]=ry;
	fitr->naxes[2]=3;
	fitr->naxis=3;
//	fitr->bitpix=16;
	return 0;
 	}

/*
 *	Convertit 1 buffer bmp24 rvb dans 3 fits f1, f2, f3
 *	(la mmoire est ralloue de celle de fitr,v,b si possible)
 */
 int bmp24to3fits16(unsigned char *rvb, int rx, int ry, fits *fitr, fits *fitg, fits *fitb){
	int i, j;
	short *rdata, *gdata, *bdata;

	if((fitr->data=realloc(fitr->data,rx* ry*sizeof(WORD)))==NULL){
		fprintf(stderr,"readfits: error alloc fit1\n");
		return(1);
		}
	if((fitg->data=realloc(fitg->data,rx* ry*sizeof(WORD)))==NULL){
		fprintf(stderr,"readfits: error alloc fit2\n");
		return(1);
		}
	if((fitb->data=realloc(fitb->data,rx* ry*sizeof(WORD)))==NULL){
		fprintf(stderr,"bmp242fits: error alloc fit3\n");
		return(1);
		}
	rdata=fitr->data;
	gdata=fitg->data;
	bdata=fitb->data;
	for (i=0; i<rx; ++i){
		for (j=0; j<ry; ++j){
			*bdata++=*rvb++;
			*gdata++=*rvb++;
			*rdata++=*rvb++;
			}	
		}
	fitr->rx=fitg->rx=fitb->rx=rx;
	fitr->ry=fitg->ry=fitb->ry=ry;
	fitr->naxis=fitg->naxis=fitb->naxis=3;
	fitr->naxes[2]=fitg->naxes[2]=fitb->naxes[2]=3;
	fitr->bitpix=fitg->bitpix=fitb->bitpix=16;

	return 0;
 	}

 int bmp8tofits(unsigned char *rgb, int rx, int ry, fits *fitr){
	int nbdata;
	int i;
	short *data;
	unsigned char *bdata;

	nbdata=rx*ry;
	if (fitr!=&gfit){
		if(fitr->bitpix==SIZESHORT){
			if((fitr->data=realloc(fitr->data,rx*ry*sizeof(WORD)))==NULL){
				fprintf(stderr,"readfits: error alloc fit1\n");
				return(1);
				}
			data=fitr->data;
			for (i=0; i<nbdata; ++i){
				*data++=*rgb++; 
				}
			}

		if(fitr->bitpix==SIZEBYTE){
			if((fitr->cdata=realloc(fitr->cdata,rx*ry*sizeof(unsigned char)))==NULL){
				fprintf(stderr,"readfits: error alloc fit1\n");
				return(1);
				}
			bdata=fitr->cdata;
			for (i=0; i<nbdata; ++i){
				*bdata++=*rgb++; 
				}
			}
		}
	else{
		data=gfit.pdata[com.cvport];
		for (i=0; i<nbdata; ++i){
			*data++=*rgb++; 
			}
		}
	
	fitr->rx=rx;
	fitr->ry=ry;
	fitr->rx=rx;
	fitr->ry=ry;
	fitr->naxes[0]=rx;
	fitr->naxes[1]=ry;
	fitr->naxes[2]=1;
	fitr->naxis=2;
	//fitr->bitpix=16;
	return 0;
 	}

 int bmp24tofits16(unsigned char *rvb, int rx, int ry, fits *fitr){
	int i,j;
	unsigned char *rgb=rvb;
	short *data;

	if((fitr->data=realloc(fitr->data,rx* ry*sizeof(WORD)))==NULL){
		fprintf(stderr,"readfits: error alloc fit1\n");
		return(1);
		}
	data=fitr->data;
	for (i=0; i<rx; ++i){
		for (j=0; j<ry; ++j){
			*data++=*rgb++; // keeps 1 byte over 3
			rgb++;
			rgb++;
			}	
		}
	fitr->rx=rx;
	fitr->ry=ry;
	fitr->naxis=2;
	fitr->naxes[0]=rx;
	fitr->naxes[1]=ry;
	fitr->naxes[2]=1;
	fitr->bitpix=16;
	return 0;
 	}

int save1fits8(char *filename, fits *fit, int layer){
	int nbdata;
	
	if(layer!=RLAYER){
			nbdata=fit->naxes[0]*=fit->naxes[1];
			memcpy(fit->cdata,fit->cdata+layer*nbdata,nbdata);
			}
	fit->naxis=2;
	fit->naxes[2]=1;
	if (savefits(filename, fit)){
		fprintf(stderr,"savefit error \n");
		}
	return 0;
	}

int tofits(char *source, char *dest){
	char filename[256];
	int nbplan;

	if (convstatus & CONVBMP){
		fprintf(stderr,"bmp convert \n");
		wfit->bitpix=SIZEBYTE;
		nbplan=readbmp(sourcefilename, wfit);

		if(nbplan==1){
			if(savefits(destfilename,wfit)){
				fprintf(stderr,"tofits: savefit error, 1 plane\n");
				}
			}
		if (nbplan==3){
			if(convstatus & CONV3X1){
				snprintf(filename,255,"%sr%s",sourceroot,destfilename);
				save1fits8(filename,wfit,RLAYER);
				snprintf(filename,255,"%sg%s",sourceroot,destfilename);
				save1fits8(filename,wfit,GLAYER);
				snprintf(filename,255,"%sb%s",sourceroot,destfilename);
				save1fits8(filename,wfit,BLAYER);
				}

			if(convstatus & CONV1X3){
				fprintf(stderr,"tofits: CONV1X3\n");
				if(savefits(destfilename,wfit)){
					fprintf(stderr,"tofits: savefit error, CONV1X3\n");
					}
				}

			if(convstatus & CONV1X1){
				save1fits8(destfilename,wfit,RLAYER);
				}
			}
		}
	else{
		int ret;

		if (convstatus & CONVPNM){
			snprintf(combuffer,511,"%s/pnmtofits %s >%s 2>/dev/null",
						pnmpath,source,dest);
			ret = system(combuffer);
			}
		else {
			snprintf(combuffer,511,"%s/%s %s 2>/dev/null| %s/pnmflip -tb 2>/dev/null|%s/pnmtofits >%s 2>/dev/null",
						pnmpath,pnmcom[type],source,pnmpath,pnmpath,dest);
			ret = system(combuffer);
			}
		fprintf(stderr,"command %s %s\n",combuffer, ret ? "failed" : "succeeded");
		}
	return 0;
	}
