#ifndef PROTO
#define PROTO
int 	commandline(FILE *);
int 	readfits(char *, fits *);
int 	readbmp(char *, fits *);
int		bmp24tofits(unsigned char *rvb, int rx, int ry, fits *fitr);
int		bmp24to3fits16(unsigned char *rvb, int rx, int ry, fits *fitr, fits *fitv, fits *fitb);
int		bmp8tofits(unsigned char *rvb, int rx, int ry, fits *fitr);
int		bmp24tofits16(unsigned char *rvb, int rx, int ry, fits *fitr);
int		reallocgfit(int x, int y);

int 	savefits(char *, fits *);
int 	savebmp(char *name, fits *f, int rx, int ry);
int 	negate(fits *);
char	*makefilename(char *);
char	*buildseqname(char *,  char *, int);
int		getindex(char *filename);
int		buildseqfile(char *name) ;
char	*buildfilename(char *, int);
void	report_fits_error( int status, char * mesg) ;
int		convert(char *from, char *suffix, int type);
int		tofits(char *from, char *to);
int		findtype(char *filename, char *suffix, int *type);
int		trytypefits(char *filename,char *suffix);
int		stat_file(char *filename,int *imagetype);
void	display_filename(char *);
int		check_seq(char *filename);
int		checkdir(char *);
int		seqsetnum(int, int );

int		process_load(int nb);
int		process_save(int nb);
int		process_convert(int nb);

int		process_loadbmp(int nb);
int		process_composervb(int nb);
int		process_bmp2fits(int nb);
int		process_trichro(int nb);

int		process_soper(int nb);
int		process_soper2(int nb);
int		process_imoper(int nb);
int		process_imoper2(int nb);
int		process_fdiv(int nb);

int		process_animate(int nb);
int		process_entropy(int nb);
int		process_medstack(int nb);
int		process_register(int nb);
int		process_composit(int nb);
int		process_unsharp2(int nb);
int		process_gauss(int nb);
int		process_gauss2(int nb);
int		process_unsharp(int nb);
int		process_crop2(int nb);
int		process_crop(int nb);
int		process_rshift2(int nb);
int		process_shift2(int nb);
int		process_shift(int nb);
int		process_cd(int nb);
int		process_wavelet(int nb);
int		process_wrecons(int nb);
int		process_log(int nb);
int		process_thresh(int nb);
int		process_threshhi(int nb);
int		process_threshlo(int nb);
int		process_nozero(int nb);
int		process_log(int nb);
int		process_ddp(int nb);
int		xrgb(int nb, int layer);
int		process_rrgb(int nb);
int		process_grgb(int nb);
int		process_brgb(int nb);
int		process_lrgb(int nb);
int		process_fwhm(int nb);
int		process_help(int nb);
int		process_exit(int nb);
int		parsewords(int idx, char *ligne);
int		processcommand(char *line);
int		commandline(FILE *input);
gint 	progress( int data );

void 	setlayers(void);
int 	writeseqfile(char *name);// filename is without suffix .seq
int 	_register(char *genname, int number, int cx, int cy, int size, int layer);
int 	reget_rawdata(float *Imag, int Nl, int Nc, short *data);
int 	siril_error(char * message,int append);

double 	gaussienne(double sigma, int size, double *gauss);
int 	unsharp(fits *,double sigma, double mult);
double 	entropy(short *, unsigned int, unsigned int);
double 	quality(fftw_complex *, unsigned int  rx, unsigned int ry, unsigned short down, unsigned short up );
int 	divide(fits *, double dv);
int 	composit(char * genname, int number, char shifted);
float 	*f_vector_alloc(int Nbr_Elem);
int 	substract(char *n1, char *n2);
int 	fwhm(fits *f);
int 	crop(fits *f);
int 	shift(int x, int y);
int 	shift2(char *in, char *out, int n, int x, int y);
int 	rshift2(char *in, char *out, int n, char *shiftfile);
int 	medstack(char *, int, char*);
//int	prepare_rawdata(float *,int *, int *);
int 	level_adjust(fits *);
int 	loglut(fits *fit);
int 	threshhi(fits *fit, int level);
int 	threshlo(fits *fit, int level);
int 	nozero(fits *fit, int level);
int 	nozero(fits *fit, int level);
int		soper(fits *a, float scalar, char oper);
int		imoper(fits *a, fits *b, char oper);
int		fdiv(fits *a, fits *b, float scalar);
int		ddp(fits *a, int lev, float coef, float sig);
int		lrgb(fits *l, fits *r, fits *g, fits *b, fits *lrgb);
int 	copyfits(fits *from, fits *to, unsigned char init,int );
int 	seqpreprocess(void);
int		preprocess(fits *brut);
double 	timing(int fin, char *info);
#ifndef isblank
int		isblank (int c);
#endif
char	*isempty(char *name);
int		writeinitfile(void);
int		readinitfile(void);
int		checkinitfile(void);
int		set_seq(char *);
int		reset_seq(sequence *seq);
int		adjust_sellabel(int i );
int		siril_init(int argc, char *argv[]);
int		changedir(char *dir);
int 	readseqfile(char *name);
BYTE	isrgb(fits * );
#endif
